/* password hashes structure */
/* we will anonymize the hashes before sending to nodes */
/* joe:hashpass:100:100:/home/joe:/bin/bash becomes */
/* user1:hashpass::: */

struct pwhash
{
  unsigned int id;		/* id, fairly superfluous */
  unsigned int cracked;		/* is this hash already cracked */
  char *plaintext;		/* plaintext of the cracked hash */
  char *pass;			/* hashed pass */
  struct pwhash *next;
};

void addhash (struct pwhash *);
struct pwhash *newhash ();
void recheck_hashes();
int save_hashes();
int compare_hash(char *, char *);
void clear_hashes();

